unit FSoft;

interface

uses
	Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls,PSAPI, TlHelp32, ClipBrd;

type
  TDestEditForm = class(TForm)
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    RadioButton3: TRadioButton;
    RadioButton4: TRadioButton;
    Button1: TButton;
    Button2: TButton;
    CheckBox1: TCheckBox;
  private
		{ Private 錾 }
		lime1Process,lime2Process,chocoaProcess,takIRCProcess : THandle;
		
		targetTextBoxHwnd :HWND;
		targetChatAppMainWinHwnd : HWND;
		FClient_Code : Byte;

		lime1MesTextBoxHwnd : HWND;
		lime2MesTextBoxHwnd : HWND;
		chocoaMesTextBoxHwnd: HWND;
		takIRCMesTextBoxHwnd: HWND;
		procedure ProsessRead(const Prosess:HWND;const ExeName: string);
		procedure GetProcess;
    function GetActiveProsess: string;
	public
		{ Public 錾 }
		function Execute : Boolean;
		procedure SendMes(const Mes:String;const SendEnter:Boolean);
		property ActiveProsess : string read GetActiveProsess;
	end;



var
	DestEditForm: TDestEditForm;
const
	CHOCOA_PROCESS_NAME : String = 'CHOCOA';
	LIME_CHAT1_PROCESS_NAME : String = 'LimeChat';
	LIME_CHAT2_PROCESS_NAME : String = 'LimeChat2';
	TAK_IRC_PROCESS_NAME : String = 'TakIRC';

	Prosesses : Array[0..4] of String =
		('vZXݒȂ','LimeChat2','CHOCOA','TakIRC','LimeChat1');

implementation

{$R *.dfm}

{ TDestEditForm }

function GetExeFileName(Handle:HWND):String;
var
	processID,dummy : DWORD;
	hProcess  : HWND;
	ModuleHandle   : DWORD;
	dest : array[0..MAX_PATH] of Char;
begin
	// vZXID
	processID := 0;
	GetWindowThreadProcessId(Handle, &processID);

	// vZXnh
	hProcess := OpenProcess(
		PROCESS_QUERY_INFORMATION or PROCESS_VM_READ, FALSE, processID);

	if hProcess = 0 then begin
		Result := '';
		Exit;
	end;
	// W[nh
	ModuleHandle := 0;
	dummy := 0;
	if(not EnumProcessModules( hProcess, @ModuleHandle, sizeof(ModuleHandle), dummy)) then begin
		Result := '';
		Exit;
	end;
	// t@C
	if(GetModuleBaseName( hProcess, ModuleHandle, dest, MAX_PATH) = 0) then begin
		Result := '';
		Exit;
	end;

	CloseHandle( hProcess);
	// hModule͎ŕႢȂ
	Result := dest;
end;

procedure TDestEditForm.ProsessRead(const Prosess:HWND;const ExeName: string);
var
	Ptr:HWND;
begin
	if (ExeName = LIME_CHAT1_PROCESS_NAME) then begin
		// Lime1

		ptr := GetWindow(Prosess, GW_CHILD);
		ptr := GetWindow(ptr, GW_HWNDNEXT);
		ptr := GetWindow(ptr, GW_CHILD);
		ptr := GetWindow(ptr, GW_HWNDNEXT);
		ptr := GetWindow(ptr, GW_CHILD);
		if Ptr <> 0 then begin
			lime1MesTextBoxHwnd := GetWindow(ptr, GW_HWNDNEXT);
			lime1Process := Prosess;
		end;
	end else if (ExeName = LIME_CHAT2_PROCESS_NAME) then begin
		// Lime2

		// gbvxEBhEeq\HĖړĨeLXg{bNX
		// EBhEnh擾B
		// ̐eq\Spy++Ŏ擾B
		ptr := GetWindow(Prosess, GW_CHILD);
		ptr := GetWindow(ptr, GW_CHILD);
		ptr := GetWindow(ptr, GW_CHILD);
		ptr := GetWindow(ptr, GW_HWNDNEXT);
		ptr := GetWindow(ptr, GW_CHILD);
		ptr := GetWindow(ptr, GW_CHILD);
		ptr := GetWindow(ptr, GW_CHILD);
		ptr := GetWindow(ptr, GW_CHILD);

		if Ptr <> 0 then begin
			lime2MesTextBoxHwnd := GetWindow(ptr, GW_HWNDNEXT);
			lime2Process := Prosess;
		end else begin //Later 2.39
			ptr := GetWindow(Prosess, GW_CHILD);
			ptr := GetWindow(ptr, GW_CHILD);
			ptr := GetWindow(ptr, GW_HWNDNEXT);
			ptr := GetWindow(ptr, GW_CHILD);
			ptr := GetWindow(ptr, GW_CHILD);
			ptr := GetWindow(ptr, GW_CHILD);
			ptr := GetWindow(ptr, GW_CHILD);
			if Ptr <> 0 then begin
				lime2MesTextBoxHwnd := GetWindow(ptr, GW_HWNDNEXT);
				lime2Process := Prosess;
			end;
		end;
	end else if (ExeName = CHOCOA_PROCESS_NAME) then begin
		// CHOCOA

		ptr := GetWindow(Prosess, GW_CHILD);
		ptr := GetWindow(ptr, GW_CHILD);
		ptr := GetWindow(ptr, GW_CHILD);
		ptr := GetWindow(ptr, GW_HWNDNEXT);
		if Ptr <> 0 then begin
			chocoaMesTextBoxHwnd := GetWindow(ptr, GW_CHILD);
			chocoaProcess := Prosess;
		end;
	end else if (ExeName = TAK_IRC_PROCESS_NAME) then begin
		// takIRC

		ptr := GetWindow(Prosess, GW_CHILD);
		ptr := GetWindow(ptr, GW_CHILD);
		ptr := GetWindow(ptr, GW_CHILD);
		if Ptr <> 0 then begin
			takIRCMesTextBoxHwnd := GetWindow(ptr, GW_HWNDNEXT);
			takIRCProcess := Prosess;
		end;
	end;
end;

procedure TDestEditForm.SendMes(const Mes: String; const SendEnter: Boolean);
var
	Buffer: PChar;
	Text : String;
begin
	if (targetChatAppMainWinHwnd <> 0) then begin
		// `bg\tgőOʂɎĂătH[JX
		SetForegroundWindow(targetChatAppMainWinHwnd);

		if (CheckBox1.Checked) then begin
			// Limechat2ł܂ƃeLXg{bNXɓ\tłȂl̂
			// Nbv{[hoRœ\t@񋟂Ă݂B

			// eLXg{bNX̓eNbv{[hɃRs[
			Clipboard.AsText := Mes;

			// HomeL[
			keybd_event(VK_HOME, 0, 0, 0);
			keybd_event(VK_HOME, 0, 2, 0);

			// Shift+EndL[ iLimechat2ƃeLXg{bNXSIԂɂȂj
			keybd_event(VK_SHIFT, 0, 0, 0);
			keybd_event(VK_END, 0, 0, 0);
			keybd_event(VK_END, 0, 2, 0);
			keybd_event(VK_SHIFT, 0, 2, 0);

			// Ctrl+V i\tj
			keybd_event(VK_CONTROL, 0, 0, 0);
			keybd_event(Byte('V'), 0, 0, 0);
			keybd_event(Byte('V'), 0, 2, 0);
			keybd_event(VK_CONTROL, 0, 2, 0);
		end else begin
			if (FClient_Code = 3) then begin
				// takIRĈƂ̓eLXg{bNX̕ĂāA
				// V̂Ă璣蒼𓾂Ȃ 
				GetMem(Buffer, 4096);
				SendMessage(targetTextBoxHwnd, WM_GETTEXT, 4096, Integer(Buffer));

				Text := Buffer;
				if (Length(Text) > 0) and (not (Text[Length(Text) - 1] in [#13,#10])) then
					Text := Text + #13#10;

				Text := Text + Mes;

				// Ctrl+END
				keybd_event(VK_CONTROL, 0, 0, 0);
				keybd_event(VK_END, 0, 0, 0);
				keybd_event(VK_END, 0, 2, 0);
				keybd_event(VK_CONTROL, 0, 2, 0);
			end else Text := Mes;

			if (targetTextBoxHwnd <> 0) then begin
				SendMessage(targetTextBoxHwnd, WM_SETTEXT, 0, Integer(PChar(Text)));
			end;
		end;

		if (SendEnter) then begin
			// ^[L[
			keybd_event(VK_RETURN, 0, 0, 0);
			keybd_event(VK_RETURN, 0, 2, 0);
		end;
	end;
end;

function EnumWindowsProc(hwindow :HWnd; lparam :LPARAM):BOOL; stdcall;
var
	PC   :PChar;
	Len  :integer;
	Name :string;
begin
	if hWindow <> 0 then begin
		Name := GetExeFileName(hwindow);

		if SameText(ExtractFileExt(Name),'.exe') then begin
			Name := ChangeFileExt(Name,'');
			DestEditForm.ProsessRead(hwindow,Name);
		end;
	end;
	Result := True;
end;

function TDestEditForm.Execute: Boolean;
var ClipRes : Boolean;
begin
	GetProcess;
	if RadioButton1.Enabled then RadioButton1.Checked := true
	else if RadioButton2.Enabled then RadioButton2.Checked := true
	else if RadioButton3.Enabled then RadioButton3.Checked := true
	else if RadioButton4.Enabled then RadioButton4.Checked := true
	else begin
		Result := False;
		ShowMessage('ΉĂvZX܂BIRCc[NĂB');   
			targetTextBoxHwnd := 0;
			targetChatAppMainWinHwnd := 0;
			FClient_Code := 0;
		Exit;
	end;

	ClipRes := CheckBox1.Checked;

	if ShowModal = mrOk then begin
		Result := True;
		if (RadioButton4.Checked) then begin
			targetTextBoxHwnd := lime1MesTextBoxHwnd;
			targetChatAppMainWinHwnd := lime1Process;
			FClient_Code := 4;
		end else if (RadioButton1.Checked) then begin
			targetTextBoxHwnd := lime2MesTextBoxHwnd;
			targetChatAppMainWinHwnd := lime2Process;
			FClient_Code := 1;
		end else if (RadioButton2.Checked) then begin
			targetTextBoxHwnd := chocoaMesTextBoxHwnd;
			targetChatAppMainWinHwnd := chocoaProcess;
			FClient_Code := 2;
		end else if (RadioButton3.Checked) then begin
			targetTextBoxHwnd := takIRCMesTextBoxHwnd;
			targetChatAppMainWinHwnd := takIRCProcess;
			FClient_Code := 3;
		end else begin
			Result := False;
			targetTextBoxHwnd := 0;
			targetChatAppMainWinHwnd := 0;
			FClient_Code := 0;
		end;
	end else begin
		Result := False;
		CheckBox1.Checked := ClipRes;
	end;
end;

function TDestEditForm.GetActiveProsess: string;
begin
	Result := Prosesses[FClient_Code];
end;

procedure TDestEditForm.GetProcess;
var
	PC   :PChar;
	function GetCaption(const Head:String;const Window:HWND):String;
	var
		Len : Integer;
		Name : String;
	begin
		if Window = 0 then begin
			Result := Head;
		end else begin
			Len := GetWindowtext(Window, PC, 256);
			setstring(Name, PC, Len);

			Result := Head + ':' + Name;
		end;
	end;
begin
	lime1Process := 0;
	lime2Process := 0;
	chocoaProcess := 0;
	takIRCProcess := 0;
	GetMem(PC, 257);

	EnumWindows(@EnumWindowsProc, 0);

	// Ȃ`bgAṽWI{^𖳌ɂ

	RadioButton1.Enabled := lime2Process <> 0;
	RadioButton1.Caption := GetCaption('LimeChat2',lime2Process);

	RadioButton2.Enabled := chocoaProcess <> 0;
	RadioButton2.Caption := GetCaption('CHOCOA',chocoaProcess);
	RadioButton3.Enabled := takIRCProcess <> 0;
	RadioButton3.Caption := GetCaption('TakIRC',takIRCProcess);
	RadioButton4.Enabled := lime1Process <> 0;
	RadioButton4.Caption := GetCaption('LimeChat1',lime1Process);

end;

end.
